package com.gic.spark.tag;

import com.gic.spark.entity.TagConditionDTO;
import com.gic.spark.entity.TagConditionValDTO;
import com.gic.spark.entity.enumtype.DomainType;
import com.gic.spark.entity.enumtype.TimeRangeType;
import com.gic.spark.entity.request.FilterRequest;
import com.gic.spark.entity.request.IntegralRequest;
import sun.util.resources.es.CalendarData_es;

import java.util.List;

/**
 * @description:
 * @author: wangxk
 * @date: 2020/4/15
 */
public class TagValueParser {

    public static FilterRequest parseFilterValue(TagConditionDTO conditionDTO){
        FilterRequest request=null;
        switch (conditionDTO.getTagEsFieldName()){
            case TagConstant.TAG_CODE_ACCUMULATED_INTEGRAL:
                request=getIntegralRequest(conditionDTO.getTagTemplateElInfo());
                break;
            case TagConstant.TAG_CODE_ABOUT_EXPIRE_INTEGRAL:

                break;
            default:break;
        }
        return request;
    }

    private static FilterRequest getIntegralRequest(List<TagConditionValDTO> conditionValDTOList) {
        IntegralRequest request=new IntegralRequest();
        for(TagConditionValDTO conditionValDTO:conditionValDTOList){
            String[] keys=conditionValDTO.getKey().split(".");
            if(keys.length==1){
                setDomainHandle(request,keys[0]);
            }else{
                switch (keys[0]){
                    case TagConstant.TAG_KEY_TYPE_TIME_RANGE:
                        switch (keys[1]){

                        }
                        break;
                    case  TagConstant.TAG_KEY_TYPE_NUMBER:

                        break;

                    default:break;
                }
            }

        }
        return request;
    }

    private static void setDomainHandle(FilterRequest request,String key){
        switch (key){
            case TagConstant.TAG_DOMAIN_ACU_INFO:
                request.setDomainType(DomainType.ACU_INFO);
                break;
            case TagConstant.TAG_DOMAIN_SCU_INFO:
                request.setDomainType(DomainType.SCU_INFO);
                break;
            case TagConstant.TAG_DOMAIN_MCU_INFO:
                request.setDomainType(DomainType.MCU_INFO);
                break;
            default:break;
        }
    }
}
